import { Type } from "@angular/core";
/**
 * Generates API block from the component type.
 * @param component Component type.
 */
export declare function astApi<T>(component: Type<T>): string;
/**
 * Generates preview template from the component type.
 * @param component Component type.
 * @param transclude Transclude template inside `<ng-content>`.
 * @param noWrap Disable component wrapping.
 */
export declare function astPreview<T>(component: Type<T>, transclude?: string, noWrap?: boolean): string;
/**
 * Generates usage block i.e. `<selector [...inputs] (...outputs)>`.
 * @param component Component type.
 */
export declare function astUsage<T>(component: Type<T>): string;
export declare function wrapPreview(preview: string, showRuler: boolean, noBg: boolean): string;
