"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var common_1 = require("./common");
var PipeUsage = /** @class */ (function () {
    function PipeUsage(data, injector) {
        this.argValues = [];
        this.result = "/* pipe result */";
        var meta = data.meta, annotation = data.annotation, realType = data.realType;
        var args = meta.methods.find(function (m) { return m.name === "transform"; }).args;
        this.meta = meta;
        this.pipeName = annotation.name;
        this.pipe = injector.get(realType);
        this.srcArg = args[0];
        this.args = args.slice(1);
    }
    PipeUsage.prototype.run = function () {
        var _this = this;
        var args = this.argValues.map(function (e) { return _this.evalInput(e.nativeElement.value); });
        this.result = this.pipe.transform.apply(this.pipe.transform, args);
    };
    PipeUsage.prototype.evalInput = function (expression) {
        try {
            return eval("(" + expression + ")");
        }
        catch (e) {
            return expression;
        }
    };
    __decorate([
        core_1.ViewChildren("argVal"),
        __metadata("design:type", Array)
    ], PipeUsage.prototype, "argValues", void 0);
    PipeUsage = __decorate([
        core_1.Component({
            selector: "n9-pipe-usage",
            template: "\n        <span>\n            <span class=\"n9-h-m\">{{</span>\n            <input #argVal type=\"text\" (input)=\"run()\"\n                    [value]=\"srcArg.defaultValue || ''\"\n                    [style.width]=\"(argVal.value.length + 1) * 7.7 + 'px'\" />\n            <span class=\"sepor\"></span>\n            <span class=\"n9-h-t\">{{ pipeName }}</span>\n            <ng-container *ngIf=\"args.length\">\n                : <input #argVal\n                        type=\"text\"\n                        *ngFor=\"let arg of args\"\n                        [name]=\"arg.name\"\n                        [value]=\"arg.defaultValue || ''\"\n                        (input)=\"run()\"\n                        [style.width]=\"(argVal.value.length + 1) * 7.7 + 'px'\" />\n            </ng-container>\n            <span class=\"n9-h-m\">}}</span>\n            => <span *ngIf=\"result\" class=\"n9-m-n\">{{ result }}</span>\n        </span>\n    ",
            styles: [
                "\n      input {\n        min-width: 30px;\n        text-align: center;\n        transition: width 0.25s;\n        padding: 0 4px;\n        box-sizing: content-box;\n      }\n\n      .sepor {\n        border-left: 1px solid;\n      }\n\n      .sepor::after {\n        content: \" \";\n        display: inline-block;\n      }\n    "
            ],
            preserveWhitespaces: true
        }),
        __param(0, core_1.Inject(common_1.StoryDataToken)),
        __metadata("design:paramtypes", [Object, core_1.Injector])
    ], PipeUsage);
    return PipeUsage;
}());
exports.PipeUsage = PipeUsage;
