import { Type } from "@angular/core";
import { ComponentProps } from "../types";
/**
 * Auto-props default values.
 */
export declare const PROP_DEFAULTS: {
    text: string;
    number: number;
    boolean: boolean;
    array: any[];
    date: Date;
    action: (args: any[]) => any[];
};
/**
 * Automatically generates props based on Angular and TypeScript metadata from class.
 * @param component Angular component class.
 * @param manualProps Manual props - these will override any auto-generated props.
 * @param defaults Defaults for auto-generated props.
 */
export declare function astProps<T>(component: Type<T>, manualProps?: ComponentProps<T>, defaults?: Defaults): ComponentProps<T>;
/**
 * Default values for component properties.
 */
export declare type Defaults = Partial<typeof PROP_DEFAULTS>;
