import { ApiDocsTemplate, MarkdownSection } from "../types";
/**
 * Generates API doc template from Markdown string.
 * Add `<!-- PREVIEW -->` to insert the preview and `<!-- API -->` to insert the API docs.
 * @param markdown Markdown string from `*.md` file.
 */
export declare function apiDocsTemplate(markdown: string): ApiDocsTemplate;
/**
 * Combines markdown template with Angular template.
 * @param markdown Markdown string from `*.md` file.
 * @param sections Custom sections (defined as `<!-- section_name -->` in `*.md` file).
 * If string is provided, the section markup will be placed after `markdown`.
 */
export declare function markdownTemplate(markdown: string, sections?: MarkdownSection[] | string): string;
export declare function ngEscape(markdownSource: string): string;
/**
 * Wraps the template with `<div class="markdown-body"></div>`.
 * @param template Markdown source template.
 */
export declare function asMarkdown(template: string): string;
