"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var platform_browser_1 = require("@angular/platform-browser");
var app_component_1 = require("./app.component");
var story_token_1 = require("./story.token");
function getModule(declarations, entryComponents, bootstrap, data, moduleMetadata) {
    var moduleMeta = {
        declarations: declarations.concat((moduleMetadata.declarations || [])),
        imports: [platform_browser_1.BrowserModule].concat((moduleMetadata.imports || [])),
        providers: [{ provide: story_token_1.STORY, useValue: __assign({}, data) }].concat((moduleMetadata.providers || [])),
        entryComponents: entryComponents.concat((moduleMetadata.entryComponents || [])),
        schemas: (moduleMetadata.schemas || []).slice(),
        bootstrap: bootstrap.slice()
    };
    var moduleClass = /** @class */ (function () {
        function DynamicModule() {
        }
        return DynamicModule;
    }());
    return core_1.NgModule(moduleMeta)(moduleClass);
}
function createComponentFromTemplate(template, styles) {
    var componentClass = /** @class */ (function () {
        function DynamicComponent() {
        }
        return DynamicComponent;
    }());
    return core_1.Component({
        template: template,
        styles: styles
    })(componentClass);
}
function initModule(storyObj) {
    var component = storyObj.component, template = storyObj.template, props = storyObj.props, styles = storyObj.styles, _a = storyObj.moduleMetadata, moduleMetadata = _a === void 0 ? {} : _a;
    var AnnotatedComponent;
    if (component) {
        AnnotatedComponent = component;
    }
    else {
        AnnotatedComponent = createComponentFromTemplate(template || "", styles);
    }
    var story = {
        component: AnnotatedComponent,
        props: props
    };
    return getModule([app_component_1.AppComponent, AnnotatedComponent], [AnnotatedComponent], [app_component_1.AppComponent], story, moduleMetadata);
}
exports.initModule = initModule;
