export declare enum PropKind {
    Regular = 0,
    OnlyGetter = 1,
    OnlySetter = 2
}
export declare enum TypeKind {
    Component = 0,
    Directive = 1,
    Pipe = 2,
    NonAngular = 3
}
export interface PropDef {
    name: string;
    type: string;
    kind: PropKind;
    defaultValue?: string;
    jsDoc?: string | false;
}
export interface ArgDef {
    name: string;
    type: string;
    defaultValue?: string;
}
export interface FnDef {
    name: string;
    args: ArgDef[];
    returnType: string;
    jsDoc?: string | false;
}
export interface TypeMetadata {
    kind: TypeKind;
    inputs: PropDef[];
    outputs: PropDef[];
    nonAngular: {
        props: PropDef[];
    };
    methods: FnDef[];
    gitUrl?: string;
    jsDoc?: string;
}
export declare function asMeta(key: any): TypeMetadata;
export declare function asType(key: any): any;
export declare function asAnnotated<T>(key: any): T;
