import { SourceFile, ClassDeclaration } from "ts-simple-ast";
import * as marked from "marked";
import { TypeMetadata } from "./metadata";
export declare function findTriggers(sourceFile: SourceFile, reader: FileReader): AnalysisTrigger[];
export declare function getMetadata(declaration: ClassDeclaration, markedOptions: marked.MarkedOptions, reader: FileReader): TypeMetadata;
export declare type FileReader = (path: string) => string;
export interface AnalysisTarget {
    key: string;
    filePath: string;
    declaration: ClassDeclaration;
}
export interface AnalysisTrigger extends Partial<AnalysisTarget> {
    replacement?: {
        start: number;
        end: number;
        text: string;
    };
}
