"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var server_1 = require("@storybook/core/server");
var merge = require("webpack-merge");
var tsconfig_paths_webpack_plugin_1 = require("tsconfig-paths-webpack-plugin");
var utils_1 = require("./utils");
var angular_configs_1 = require("./angular-configs");
var webpack_base_1 = require("./webpack-base");
var configDir = utils_1.init();
var tsConfigPath = utils_1.findTsConfigPath(configDir, process.cwd());
angular_configs_1.getAngularConfig(configDir).then(function (angular) {
    server_1.buildStatic({
        packageJson: require("../../package.json"),
        wrapInitialConfig: function (core) { return wrapConfig(angular); },
        wrapDefaultConfig: function (core) { return wrapConfig(angular); }
    });
});
var PROD_CONFIG = {
    mode: "production",
    module: {
        rules: [
            {
                test: /\.ts$/,
                use: [
                    {
                        loader: require.resolve("ts-loader"),
                        options: {
                            configFile: tsConfigPath,
                            transpileOnly: false
                        }
                    },
                    require.resolve("angular2-template-loader")
                ]
            }
        ]
    },
    resolve: {
        plugins: [new tsconfig_paths_webpack_plugin_1.TsconfigPathsPlugin()]
    }
};
function wrapConfig(angular) {
    return merge(webpack_base_1.baseConfig(angular, { configDir: configDir, tsConfigPath: tsConfigPath }), PROD_CONFIG);
}
