"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var server_1 = require("@storybook/core/server");
var webpack_1 = require("webpack");
var merge = require("webpack-merge");
var tsconfig_paths_webpack_plugin_1 = require("tsconfig-paths-webpack-plugin");
var utils_1 = require("./utils");
var angular_configs_1 = require("./angular-configs");
var webpack_base_1 = require("./webpack-base");
var configDir = utils_1.init();
var tsConfigPath = utils_1.findTsConfigPath(configDir, process.cwd());
angular_configs_1.getAngularConfig(configDir).then(function (angular) {
    server_1.buildDev({
        packageJson: require("../../package.json"),
        wrapInitialConfig: function (core) { return wrapConfig(angular); },
        wrapDefaultConfig: function (core) { return wrapConfig(angular); }
    });
});
var ClearTerminalPlugin = /** @class */ (function () {
    function ClearTerminalPlugin() {
    }
    ClearTerminalPlugin.prototype.apply = function (compiler) {
        compiler.hooks.emit.tap("clear-terminal", function () {
            process.stdout.write("\x1B[2J\x1B[3J\x1B[H");
        });
    };
    return ClearTerminalPlugin;
}());
var MIDDLEWARE_CONFIG = {
    devServer: {
        clientLogLevel: "none",
        stats: "minimal"
    }
};
var DEV_CONFIG = __assign({ mode: "development", entry: {
        preview: [require.resolve("webpack-hot-middleware/client") + "?reload=true"]
    }, module: {
        rules: [
            {
                test: /\.ts$/,
                use: [
                    {
                        loader: require.resolve("ts-loader"),
                        options: {
                            configFile: tsConfigPath,
                            transpileOnly: true
                        }
                    },
                    require.resolve("angular2-template-loader")
                ]
            }
        ]
    }, resolve: {
        plugins: [new tsconfig_paths_webpack_plugin_1.TsconfigPathsPlugin()]
    }, plugins: [
        new webpack_1.HotModuleReplacementPlugin(),
        new webpack_1.EvalSourceMapDevToolPlugin({
            exclude: /node_modules/,
            columns: false
        }),
        new ClearTerminalPlugin()
    ] }, MIDDLEWARE_CONFIG);
function wrapConfig(angular) {
    return merge(webpack_base_1.baseConfig(angular, { configDir: configDir, tsConfigPath: tsConfigPath }), DEV_CONFIG);
}
