"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var marked = require("marked");
var highlight = require("highlight.js");
function markedLoaderOptions() {
    return {
        renderer: createRenderer(),
        highlight: function (code) { return highlight.highlightAuto(code).value; }
    };
}
exports.markedLoaderOptions = markedLoaderOptions;
function createRenderer() {
    var renderer = new marked.Renderer();
    var defaultLink = renderer.link;
    renderer.link = function (href, title, text) {
        if (href.startsWith("sb://")) {
            var sbArgs = href
                .replace("sb://", "")
                .replace(/\+/g, " ")
                .split("/");
            var newHref = "/?selectedKind=" + sbArgs[0] + "&selectedStory=" + sbArgs[1];
            return "<a data-sb-kind=\"" + sbArgs[0] + "\" data-sb-story=\"" + sbArgs[1] + "\" href=\"" + newHref + "\">" + text + "</a>";
        }
        return defaultLink.call(renderer, href, title, text);
    };
    return renderer;
}
