"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var PLUGIN_NAME = "ngx-storybook-plugin";
var DEFAULT_OPTIONS = {};
var META_MODULE = require.resolve("./analysis/n9ngxstb.meta.js");
/**
 * Storybook plugin that renders story metadata.
 */
var StorybookPlugin = /** @class */ (function () {
    /**
     * Creates new instance of StorybookPlugin.
     * @param options Plugin options.
     */
    function StorybookPlugin(options) {
        if (options === void 0) { options = {}; }
        var _this = this;
        this.metadata = {};
        this.currentRunMetadata = {};
        this.reset = function () {
            _this.currentRunMetadata = {};
        };
        this._setLoaderContext = function (context) {
            context["n9ngxstb.plugin"] = _this;
        };
        this._saveAstMetadata = function (modules, compilation) {
            var metaModule = modules.find(function (m) { return m.resource === META_MODULE; });
            if (!metaModule) {
                return;
            }
            metaModule._source._value = "module.exports=" + JSON.stringify(_this.metadata);
            metaModule._buildHash = Date.now().toString();
            _this.reset();
        };
        this._options = __assign({}, DEFAULT_OPTIONS, options);
    }
    /**
     * Creates a loader needed for this plugin to work.
     */
    StorybookPlugin.loader = function () {
        return require.resolve("./loader");
    };
    Object.defineProperty(StorybookPlugin.prototype, "options", {
        get: function () {
            return this._options;
        },
        enumerable: true,
        configurable: true
    });
    StorybookPlugin.prototype.apply = function (compiler) {
        var _this = this;
        compiler.hooks.compilation.tap(PLUGIN_NAME, function (c) {
            c.hooks.normalModuleLoader.tap(PLUGIN_NAME, _this._setLoaderContext);
            c.hooks.finishModules.tap(PLUGIN_NAME, function (m) { return _this._saveAstMetadata(m, c); });
        });
    };
    return StorybookPlugin;
}());
exports.StorybookPlugin = StorybookPlugin;
