"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var FS = require("fs");
var PATH = require("path");
var JSON5 = require("json5");
var core_1 = require("@angular-devkit/core");
function findProject() {
    var dirsToSearch = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        dirsToSearch[_i] = arguments[_i];
    }
    for (var _a = 0, dirsToSearch_1 = dirsToSearch; _a < dirsToSearch_1.length; _a++) {
        var dir = dirsToSearch_1[_a];
        var path = PATH.resolve(dir, "./angular.json");
        if (FS.existsSync(path)) {
            var workspace = readJson(path);
            return {
                project: workspace.projects[workspace.defaultProject || Object.keys(workspace.projects)[0]],
                rootDir: core_1.normalize(process.cwd())
            };
        }
    }
    return {};
}
exports.findProject = findProject;
function findTsConfigPath() {
    var dirsToSearch = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        dirsToSearch[_i] = arguments[_i];
    }
    for (var _a = 0, dirsToSearch_2 = dirsToSearch; _a < dirsToSearch_2.length; _a++) {
        var dir = dirsToSearch_2[_a];
        var path = PATH.resolve(dir, "./tsconfig.json");
        if (FS.existsSync(path)) {
            return path;
        }
    }
}
exports.findTsConfigPath = findTsConfigPath;
function init() {
    appendToArgAndReturn(function (s) { return PATH.resolve(__dirname, "../public") + (s ? "," + s : ""); }, "-s", "--static-dir");
    var configDir = appendToArgAndReturn(function () { return ""; }, "-c", "--config-dir");
    return PATH.resolve(process.cwd(), configDir);
}
exports.init = init;
function appendToArgAndReturn(append) {
    var aliases = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        aliases[_i - 1] = arguments[_i];
    }
    for (var _a = 0, aliases_1 = aliases; _a < aliases_1.length; _a++) {
        var alias = aliases_1[_a];
        var aliasIndex = process.argv.indexOf(alias);
        if (aliasIndex > -1) {
            return (process.argv[aliasIndex + 1] += append(process.argv[aliasIndex + 1]));
        }
    }
    var newArg = append("");
    if (newArg) {
        process.argv.push(aliases[0], newArg);
    }
}
function readJson(path) {
    var _a = JSON5.parse(FS.readFileSync(path, "utf-8")), __extends = _a.__extends, current = __rest(_a, ["__extends"]);
    if (__extends) {
        var parent_1 = readJson(PATH.resolve(PATH.dirname(path), __extends));
        overrideJson(parent_1, current);
        return parent_1;
    }
    return current;
}
function overrideJson(base, derived) {
    if (!base || !derived) {
        return;
    }
    Object.keys(derived).forEach(function (k) {
        var baseValue = base[k];
        var derivedValue = derived[k];
        if (!derivedValue ||
            typeof derivedValue !== typeof baseValue ||
            Array.isArray(derivedValue) !== Array.isArray(baseValue)) {
            return;
        }
        if (Array.isArray(derivedValue)) {
            base[k] = baseValue.concat(derivedValue);
        }
        else if (typeof derivedValue === "object") {
            overrideJson(baseValue, derivedValue);
        }
        else {
            base[k] = derivedValue;
        }
    });
}
